### Method

# Gio InputStream read_bytes

since: 2.34

#### Declaration

    GBytes*
    g_input_stream_read_bytes (
      GInputStream* stream,
      gsize count,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Like g_input_stream_read(), this tries to read `count` bytes from the stream in a blocking fashion. However, rather than reading into a user-supplied buffer, this will create a new `GBytes` containing the data that was read. This may be easier to use from language bindings.

If count is zero, returns a zero-length `GBytes` and does nothing. A value of `count` larger than `G_MAXSSIZE` will cause a `G_IO_ERROR_INVALID_ARGUMENT` error.

On success, a new `GBytes` is returned. It is not an error if the size of this object is not the same as the requested size, as it can happen e.g. near the end of a file. A zero-length `GBytes` is returned on end of file (or if `count` is zero), but never otherwise.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. If an operation was partially finished when the operation was cancelled the partial result will be returned, without an error.

On error `NULL` is returned and `error` is set accordingly.

Available since: 2.34

#### Parameters

`count`

  Type: `gsize`

  Maximum number of bytes that will be read from the stream. Common values include 4096 and 8192.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GBytes`

A new `GBytes`, or `NULL` on error.

The caller of the method takes ownership of the data, and is responsible for freeing it.